import {CoreClient} from "../client/client";
import AutoKickConfig from "../database/entities/AutoKickConfig";

export default async function AutoKick() {
    const client = CoreClient.baseClient;
    const autoKickConfigs = await AutoKickConfig.FetchAll(AutoKickConfig);

    for (let config of autoKickConfigs) {
        const guild = client.guilds.cache.find(x => x.id == config.ServerId) || await client.guilds.fetch(config.ServerId);

        if (!guild) {
            continue;
        }

        await guild.members.fetch();

        const role = guild.roles.cache.find(x => x.id == config.RoleId);

        if (!role) {
            continue;
        }

        for (let memberEntity of role.members) {
            const member = memberEntity[1];

            if (!member.kickable) {
                continue;
            }

            const whenToKick = new Date(member.joinedTimestamp! + config.KickTime);
            const now = new Date();

            if (whenToKick < now) {
                await member.kick("Auto Kicked");
            }
        }
    }
}
